<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: /Users/dlekshmi/Desktop/Repos/PhD/GTSBox/Projects/Llamosi2016/Model/AMICIModel/simulate_Llamosi2016.m Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_7a6499598ddcfcabe96e224cb4a6d834.html">Projects</a></li><li class="navelem"><a class="el" href="../../dir_14cef3b922ba0db668f51262197138d9.html">Llamosi2016</a></li><li class="navelem"><a class="el" href="../../dir_b568ff35628e6f9749400d8da614780c.html">Model</a></li><li class="navelem"><a class="el" href="../../dir_c41e53e58e92f169334ed068ac49ff71.html">AMICIModel</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">simulate_Llamosi2016.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../d0/d59/simulate___llamosi2016_8m.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;% <a class="code" href="../../d0/d59/simulate___llamosi2016_8m.html#aa8cf0f00388f5225a610972a57c412f5">simulate_Llamosi2016</a>.m is the matlab <span class="keyword">interface </span>to the cvodes mex</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;%   which simulates the ordinary differential equation and respective</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;%   sensitivities according to user specifications.</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;%   <span class="keyword">this</span> routine was generated <span class="keyword">using</span> AMICI commit # in branch unknown branch in repo unknown repository.</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;%</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;% USAGE:</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;% ======</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;% [...] = <a class="code" href="../../d0/d59/simulate___llamosi2016_8m.html#aa8cf0f00388f5225a610972a57c412f5">simulate_Llamosi2016</a>(tout,theta)</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;% [...] = <a class="code" href="../../d0/d59/simulate___llamosi2016_8m.html#aa8cf0f00388f5225a610972a57c412f5">simulate_Llamosi2016</a>(tout,theta,kappa,data,options)</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;% [status,tout,x,y,sx,sy] = <a class="code" href="../../d0/d59/simulate___llamosi2016_8m.html#aa8cf0f00388f5225a610972a57c412f5">simulate_Llamosi2016</a>(...)</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;%</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;% INPUTS:</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;% =======</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;% tout ... 1 dimensional vector of timepoints at which a solution to the ODE is desired</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;% theta ... 1 dimensional parameter vector of parameters <span class="keywordflow">for</span> which sensitivities are desired.</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;%           <span class="keyword">this</span> corresponds to the specification in model.sym.p</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;% kappa ... 1 dimensional parameter vector of parameters <span class="keywordflow">for</span> which sensitivities are not desired.</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;%           <span class="keyword">this</span> corresponds to the specification in model.sym.k</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;% data ... <span class="keyword">struct </span>containing the following fields:</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;%     Y ... 2 dimensional matrix containing data.</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;%           columns must correspond to observables and rows to time-points</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;%     Sigma_Y ... 2 dimensional matrix containing standard deviation of data.</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;%           columns must correspond to observables and rows to time-points</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;%     T ... (optional) 2 dimensional matrix containing events.</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;%           columns must correspond to event-types and rows to possible event-times</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;%     Sigma_T ... (optional) 2 dimensional matrix containing standard deviation of events.</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;%           columns must correspond to event-types and rows to possible event-times</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;% options ... additional options to pass to the cvodes solver. Refer to the cvodes guide for more documentation.</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;%    .atol ... absolute tolerance for the solver. default is specified in the user-provided syms function.</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;%        default value is 1e-16</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;%    .rtol ... relative tolerance for the solver. default is specified in the user-provided syms function.</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;%        default value is 1e-8</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;%    .maxsteps    ... maximal number of integration steps. default is specified in the user-provided syms function.</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;%        default value is 1e4</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;%    .tstart    ... start of integration. for all timepoints before this, values will be set to initial value.</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;%        default value is 0</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;%    .sens_ind ... 1 dimensional vector of indexes for which sensitivities must be computed.</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;%        default value is 1:length(theta).</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;%    .x0 ... user-provided state initialisation. This should be a vector of dimension [#states, 1].</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;%        default is state initialisation based on the model definition.</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;%    .sx0 ... user-provided sensitivity initialisation. this should be a matrix of dimension [#states x #parameters].</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;%        default is sensitivity initialisation based on the derivative of the state initialisation.</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;%    .lmm    ... linear multistep method for forward problem.</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;%        1: Adams-Bashford</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;%        2: BDF (DEFAULT)</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;%    .iter    ... iteration method for linear multistep.</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;%        1: Functional</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;%        2: Newton (DEFAULT)</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;%    .linsol   ... linear solver module.</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;%        direct solvers:</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;%        1: Dense</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;%        2: Band (not implemented)</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;%        3: LAPACK Dense (not implemented)</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;%        4: LAPACK Band  (not implemented)</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;%        5: Diag (not implemented)</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;%        implicit krylov solvers:</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;%        6: SPGMR</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;%        7: SPBCG</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;%        8: SPTFQMR</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;%        sparse solvers:</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;%        9: KLU (DEFAULT)</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;%    .stldet   ... flag for stability limit detection. this should be turned on for stiff problems.</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;%        0: OFF</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;%        1: ON (DEFAULT)</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;%    .sensi   ... sensitivity order.</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;%        0: OFF (DEFAULT)</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;%        1: first</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;%        2: second</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;%    .sensi_meth   ... method for sensitivity analysis.</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;%        0: no sensitivity analysis</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;%        1 or &#39;forward&#39;: forward sensitivity analysis (DEFAULT)</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;%        2 or &#39;adjoint&#39;: adjoint sensitivity analysis </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;%        3 or &#39;ss&#39;: defined but not documented </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;%    .adjoint   ... flag for adjoint sensitivity analysis.</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;%        true: on </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;%        false: off (DEFAULT)</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;%        NO LONGER USED: Replaced by sensi_meth</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;%    .ism   ... only available for sensi_meth == 1. Method for computation of forward sensitivities.</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;%        1: Simultaneous (DEFAULT)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;%        2: Staggered</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;%        3: Staggered1</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;%    .Nd   ... only available for sensi_meth == 2. Number of Interpolation nodes for forward solution. </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;%        default is 1000. </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;%    .interpType   ... only available for sensi_meth == 2. Interpolation method for forward solution.</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;%        1: Hermite (DEFAULT for problems without discontinuities)</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;%        2: Polynomial (DEFAULT for problems with discontinuities)</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;%    .ordering   ... online state reordering.</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;%        0: AMD reordering (default)</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;%        1: COLAMD reordering</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;%        2: natural reordering</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;%    .newton_maxsteps   ... maximum newton steps</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;%        default value is 40</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;%        a value of 0 will disable the newton solver</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;%    .newton_maxlinsteps   ... maximum linear steps</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;%        default value is 100</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;%    .newton_preeq   ... preequilibration of system via newton solver</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;%        default value is false</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;%    .pscale   ... parameter scaling</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;%        []: (DEFAULT) use value specified in the model (fallback: &#39;lin&#39;)</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;%        0 or &#39;lin&#39;: linear</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;%        1 or &#39;log&#39;: natural log (base e)</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;%        2 or &#39;log10&#39;: log to the base 10</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;%</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;% Outputs:</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;% ========</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;% sol.status ... flag for status of integration. generally status&lt;0 for failed integration</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;% sol.t ... vector at which the solution was computed</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;% sol.llh ... likelihood value</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;% sol.chi2 ... chi2 value</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;% sol.sllh ... gradient of likelihood</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;% sol.s2llh ... hessian or hessian-vector-product of likelihood</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;% sol.x ... time-resolved state vector</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;% sol.y ... time-resolved output vector</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;% sol.sx ... time-resolved state sensitivity vector</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;% sol.sy ... time-resolved output sensitivity vector</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;% sol.z ... event output</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;% sol.sz ... sensitivity of event output</div>
<div class="line"><a name="l00118"></a><span class="lineno"><a class="line" href="../../d0/d59/simulate___llamosi2016_8m.html#aa8cf0f00388f5225a610972a57c412f5">  118</a></span>&#160;function varargout = simulate_Llamosi2016(varargin)</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;% DO NOT CHANGE ANYTHING IN THIS FILE UNLESS YOU ARE VERY SURE ABOUT WHAT YOU ARE DOING</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;% MANUAL CHANGES TO THIS FILE CAN RESULT IN WRONG SOLUTIONS AND CRASHING OF MATLAB</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;if(nargin&lt;2)</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    error(&#39;Not enough input arguments.&#39;);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;else</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    tout=varargin{1};</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    theta=varargin{2};</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;end</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;if(nargin&gt;=3)</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    kappa=varargin{3};</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;else</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    kappa=[];</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;end</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160; </div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;if(length(theta)&lt;3)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    error(&#39;provided parameter vector is too short&#39;);</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;end</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;xscale = [];</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;if(nargin&gt;=5)</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    if(isa(varargin{5},&#39;amioption&#39;))</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        options_ami = varargin{5};</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    else</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        options_ami = amioption(varargin{5});</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    end</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;else</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    options_ami = amioption();</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;end</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;if(isempty(options_ami.sens_ind))</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    options_ami.sens_ind = 1:3;</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;end</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;if(isempty(options_ami.pscale))</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    options_ami.pscale = &#39;lin&#39; ;</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;end</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;if(nargout&gt;1)</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    if(nargout&gt;6)</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        options_ami.sensi = 2;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        options_ami.sensi_meth = &#39;forward&#39;;</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    elseif(nargout&gt;4)</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        options_ami.sensi = 1;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        options_ami.sensi_meth = &#39;forward&#39;;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    else</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        options_ami.sensi = 0;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    end</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;end</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;nplist = length(options_ami.sens_ind); % MUST NOT CHANGE THIS VALUE</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;if(nplist == 0)</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    options_ami.sensi = 0;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;end</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;if(options_ami.sensi &gt; 1)</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    nxfull = 12;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;else</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    nxfull = 3;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;end</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;plist = options_ami.sens_ind-1;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;if(nargin&gt;=4)</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    if(isempty(varargin{4}))</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        data=[];</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    else</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        if(isa(varargin{4},&#39;amidata&#39;))</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;             data=varargin{4};</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            data=amidata(varargin{4});</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        end</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        <span class="keywordflow">if</span>(data.ne&gt;0)</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            options_ami.nmaxevent = data.ne;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;            data.ne = options_ami.nmaxevent;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        end</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        <span class="keywordflow">if</span>(isempty(kappa))</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            kappa = data.condition;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        end</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="keywordflow">if</span>(isempty(tout))</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            tout = data.t;</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        end</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    end</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="keywordflow">else</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    data=[];</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;end</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="keywordflow">if</span>(~all(tout==sort(tout)))</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    error(<span class="stringliteral">&#39;Provided time vector is not monotonically increasing!&#39;</span>);</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;end</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;<span class="keywordflow">if</span>(max(options_ami.sens_ind)&gt;3)</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    error(<span class="stringliteral">&#39;Sensitivity index exceeds parameter dimension!&#39;</span>)</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;end</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;if(length(kappa)&lt;6)</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    error(&#39;provided condition vector is too <span class="keywordtype">short</span>&#39;);</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;end</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;init = struct();</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;if(~isempty(options_ami.x0))</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    if(size(options_ami.x0,2)~=1)</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        error(&#39;x0 field must be a column vector!&#39;);</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    end</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    if(size(options_ami.x0,1)~=nxfull)</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        error(&#39;Number of rows in x0 field does not agree with number of states!&#39;);</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    end</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    init.x0 = options_ami.x0;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;end</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;if(~isempty(options_ami.sx0))</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    if(size(options_ami.sx0,2)~=nplist)</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        error(&#39;Number of columns in sx0 field does not agree with number of model parameters!&#39;);</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    end</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    if(size(options_ami.sx0,1)~=nxfull)</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        error(&#39;Number of rows in sx0 field does not agree with number of states!&#39;);</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    end</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;end</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;if(options_ami.sensi&lt;2)</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    sol = ami_Llamosi2016(tout,theta(1:3),kappa(1:6),options_ami,plist,xscale,init,data);</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;else</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    sol = ami_Llamosi2016_o2(tout,theta(1:3),kappa(1:6),options_ami,plist,xscale,init,data);</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;end</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;if(options_ami.sensi == 2)</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    if(~(options_ami.sensi_meth==2))</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        sz = zeros(size(sol.z,1),0,length(theta(options_ami.sens_ind)));</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        ssigmaz = zeros(size(sol.z,1),0,length(theta(options_ami.sens_ind)));</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        srz = zeros(size(sol.z,1),0,length(theta(options_ami.sens_ind)));</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        for iz = 1:0</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;            sz(:,iz,:) = sol.sz(:,2*iz-1,:);</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;            ssigmaz(:,iz,:) = sol.ssigmaz(:,2*iz-1,:);</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            srz(:,iz,:) = sol.srz(:,2*iz-1,:);</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        end</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        sol.s2x = reshape(sol.sx(:,4:end,:),length(tout),3,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        sol.s2y = reshape(sol.sy(:,3:end,:),length(tout),2,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        sol.s2sigmay = reshape(sol.ssigmay(:,3:end,:),length(tout),2,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        s2z = zeros(size(sol.z,1),0,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        s2sigmaz = zeros(size(sol.z,1),0,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        s2rz = zeros(size(sol.z,1),0,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        for iz = 1:0</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;            sol.s2z(:,iz,:,:) = reshape(sol.sz(:,((iz-1)*(3+1)+2):((iz-1)*(3+1)+3+1),:),options_ami.nmaxevent,1,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;            sol.s2sigmaz(:,iz,:,:) = reshape(sol.ssigmaz(:,((iz-1)*(3+1)+2):((iz-1)*(3+1)+3+1),:),options_ami.nmaxevent,1,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;            sol.s2rz(:,iz,:,:) = reshape(sol.srz(:,((iz-1)*(3+1)+2):((iz-1)*(3+1)+3+1),:),options_ami.nmaxevent,1,3,length(options_ami.sens_ind));</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        end</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        sol.sx = sol.sx(:,1:3,:);</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        sol.sy = sol.sy(:,1:2,:);</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        sol.ssigmay = sol.ssigmay(:,1:2,:);</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        if(iz&gt;0)</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            sol.sz = sz;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;            sol.ssigmaz = ssigmaz;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;            sol.srz = srz;</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;         end</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    end</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    sol.x = sol.x(:,1:3);</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    sol.y = sol.y(:,1:2);</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    sol.sigmay = sol.sigmay(:,1:2);</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    sol.z = sol.z(:,1:0);</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    sol.rz = sol.rz(:,1:0);</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    sol.sigmaz = sol.sigmaz(:,1:0);</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;end</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;if(nargout&gt;1)</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    varargout{1} = sol.status;</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    varargout{2} = sol.t;</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    varargout{3} = sol.x;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    varargout{4} = sol.y;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="keywordflow">if</span>(nargout&gt;4)</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        varargout{5} = sol.sx;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        varargout{6} = sol.sy;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        <span class="keywordflow">if</span>(nargout&gt;6)</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            varargout{7} = sol.s2x;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;            varargout{8} = sol.s2y;</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        end</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    end</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;<span class="keywordflow">else</span></div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    varargout{1} = sol;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;end</div>
<div class="line"><a name="l00286"></a><span class="lineno"><a class="line" href="../../d0/d59/simulate___llamosi2016_8m.html#ae49d26a2d42a208c9de173495f183fb9">  286</a></span>&#160;<span class="keyword">function</span> chainRuleFactors = <a class="code" href="../../d0/d59/simulate___llamosi2016_8m.html#ae49d26a2d42a208c9de173495f183fb9">getChainRuleFactors</a>(pscale, theta, sens_ind)</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordflow">if</span>(length(pscale) == 1 &amp;&amp; length(sens_ind) ~= length(pscale))</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        chainRuleFactors = arrayfun(@(x, ip) <a class="code" href="../../d0/d59/simulate___llamosi2016_8m.html#ad2edaeff3e435cef9e65433e4656eb05">getChainRuleFactor</a>(x, theta(ip)), repmat(pscale, 1, length(sens_ind)), sens_ind);</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        chainRuleFactors = arrayfun(@(x, ip) <a class="code" href="../../d0/d59/simulate___llamosi2016_8m.html#ad2edaeff3e435cef9e65433e4656eb05">getChainRuleFactor</a>(x, theta(ip)), pscale, sens_ind);</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    end</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;end</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160; </div>
<div class="line"><a name="l00294"></a><span class="lineno"><a class="line" href="../../d0/d59/simulate___llamosi2016_8m.html#ad2edaeff3e435cef9e65433e4656eb05">  294</a></span>&#160;<span class="keyword">function</span> chainRuleFactor = <a class="code" href="../../d0/d59/simulate___llamosi2016_8m.html#ad2edaeff3e435cef9e65433e4656eb05">getChainRuleFactor</a>(pscale, parameterValue)</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="keywordflow">switch</span> (pscale)</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keywordflow">case</span> 1</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;            chainRuleFactor = exp(parameterValue);</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        <span class="keywordflow">case</span> 2</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            chainRuleFactor = 10.^parameterValue*log(10);</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        otherwise</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            chainRuleFactor = 1.0;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    end</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;end</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160; </div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;end</div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="asimulate___llamosi2016_8m_html_aa8cf0f00388f5225a610972a57c412f5"><div class="ttname"><a href="../../d0/d59/simulate___llamosi2016_8m.html#aa8cf0f00388f5225a610972a57c412f5">simulate_Llamosi2016</a></div><div class="ttdeci">function simulate_Llamosi2016(in varargin)</div></div>
<div class="ttc" id="asimulate___llamosi2016_8m_html_ae49d26a2d42a208c9de173495f183fb9"><div class="ttname"><a href="../../d0/d59/simulate___llamosi2016_8m.html#ae49d26a2d42a208c9de173495f183fb9">getChainRuleFactors</a></div><div class="ttdeci">function getChainRuleFactors(in pscale, in theta, in sens_ind)</div></div>
<div class="ttc" id="asimulate___llamosi2016_8m_html_ad2edaeff3e435cef9e65433e4656eb05"><div class="ttname"><a href="../../d0/d59/simulate___llamosi2016_8m.html#ad2edaeff3e435cef9e65433e4656eb05">getChainRuleFactor</a></div><div class="ttdeci">function getChainRuleFactor(in pscale, in parameterValue)</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:29 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
